Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2008)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2011)
@@ -4275,5 +4021,4 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE usm_write_restart_data
-
     
        IMPLICIT NONE
@@ -4306,50 +4051,34 @@
 
 
-
-!------------------------------------------------------------------------------!
+!------------------------------------------------------------------------------!
+!
 ! Description:
 ! ------------
-!> Check parameters routine for urban surface model
-!------------------------------------------------------------------------------!
-    SUBROUTINE usm_check_parameters
-
-    
-       USE control_parameters,                                                 &
-           ONLY:  bc_pt_b, bc_q_b, constant_flux_layer, large_scale_forcing,   &
-                  lsf_surf, topography
-
-!
-!--    Dirichlet boundary conditions are required as the surface fluxes are
-!--    calculated from the temperature/humidity gradients in the urban surface
-!--    model
-       IF ( bc_pt_b == 'neumann'  .OR.  bc_q_b == 'neumann' )  THEN
-          message_string = 'urban surface model requires setting of '//        &
-                           'bc_pt_b = "dirichlet" and '//                      &
-                           'bc_q_b  = "dirichlet"'
-          CALL message( 'check_parameters', 'PA0590', 1, 2, 0, 6, 0 )
-       ENDIF
-
-       IF ( .NOT. constant_flux_layer )  THEN
-          message_string = 'urban surface model requires '//                   &
-                           'constant_flux_layer = .T.'
-          CALL message( 'check_parameters', 'PA0591', 1, 2, 0, 6, 0 )
-       ENDIF
-!        
-!--    Surface forcing has to be disabled for LSF in case of enabled 
-!--    urban surface module
-       IF ( large_scale_forcing )  THEN
-          lsf_surf = .FALSE.
-       ENDIF
-!
-!--    Topography
-       IF ( topography == 'flat' )  THEN
-          message_string = 'topography /= "flat" is required '//               &
-                           'when using the urban surface model'
-          CALL message( 'check_parameters', 'PA0592', 1, 2, 0, 6, 0 )
-       ENDIF
-
-
-    END SUBROUTINE usm_check_parameters
-
+!> Subroutine stores svf and svfsurf data to files
+!------------------------------------------------------------------------------!
+    SUBROUTINE usm_write_svf_to_file
+    
+        IMPLICIT NONE
+        INTEGER             :: fsvf = 89
+        INTEGER             :: i
+        
+        DO  i = 0, io_blocks-1
+            IF ( i == io_group )  THEN
+                OPEN ( fsvf, file=TRIM(svf_file_name)//TRIM(coupling_char)//myid_char,               &
+                    form='unformatted', status='new' )
+
+                WRITE ( fsvf )  usm_version
+                WRITE ( fsvf )  nsvfcsfl, nsvfl
+                WRITE ( fsvf )  svf
+                WRITE ( fsvf )  svfsurf
+                WRITE ( fsvf )  TRIM(svf_code)
+                
+                CLOSE (fsvf)
+#if defined( __parallel )
+                CALL mpi_barrier( comm2d, ierr )
+#endif
+            ENDIF
+        ENDDO
+    END SUBROUTINE usm_write_svf_to_file
 
 
@@ -4361,5 +4090,4 @@
     SUBROUTINE usm_parin
 
-
        IMPLICIT NONE
 
@@ -4367,5 +4095,4 @@
 
        NAMELIST /urban_surface_par/                                            &  
-                           debug_prints,                                       &
                            land_category,                                      &
                            mrt_factors,                                        &
@@ -4380,6 +4107,6 @@
                            usm_energy_balance_land,                            &
                            usm_energy_balance_wall,                            &
+                           usm_material_model,                                 &
                            usm_lad_rma,                                        &
-                           usm_material_model,                                 &
                            wall_category,                                      &
                            write_svf_on_init
@@ -4407,9 +4134,6 @@
  10    CONTINUE
     
-    
     END SUBROUTINE usm_parin    
 
-    
-    
     
 !------------------------------------------------------------------------------!
@@ -4419,5 +4143,5 @@
 !> Block of auxiliary subroutines:
 !> 1. quicksort and corresponding comparison
-!> 2. merge_and_grow_csf for implementation of "dynamical growing" array
+!> 2. usm_merge_and_grow_csf for implementation of "dynamical growing" array
 !>    for svf and csf
 !------------------------------------------------------------------------------!    
@@ -4425,6 +4149,6 @@
       TYPE (t_svf), INTENT(in) :: svf1,svf2
       LOGICAL                  :: res
-      IF ( svf1%isurflt < svf2%isurflt .OR.   &
-          (svf1%isurflt == svf2%isurflt .AND. svf1%isurfs < svf2%isurfs) ) THEN
+      IF ( svf1%isurflt < svf2%isurflt  .OR.    &
+          (svf1%isurflt == svf2%isurflt  .AND.  svf1%isurfs < svf2%isurfs) )  THEN
           res = .TRUE.
       ELSE
@@ -4434,8 +4158,8 @@
     
  
-    ! quicksort.f -*-f90-*-
-    ! Author: t-nissie, adaptation J.Resler
-    ! License: GPLv3
-    ! Gist: https://gist.github.com/t-nissie/479f0f16966925fa29ea
+!-- quicksort.f -*-f90-*-
+!-- Author: t-nissie, adaptation J.Resler
+!-- License: GPLv3
+!-- Gist: https://gist.github.com/t-nissie/479f0f16966925fa29ea
     RECURSIVE SUBROUTINE quicksort_svf(svfl, first, last)
         IMPLICIT NONE
@@ -4456,11 +4180,11 @@
                 j=j-1
             ENDDO
-            IF (i >= j) EXIT
+            IF ( i >= j ) EXIT
             t = svfl(i);  svfl(i) = svfl(j);  svfl(j) = t
             i=i+1
             j=j-1
         ENDDO
-        IF (first < i-1) CALL quicksort_svf(svfl, first, i-1)
-        IF (j+1 < last)  CALL quicksort_svf(svfl, j+1, last)
+        IF ( first < i-1 ) CALL quicksort_svf(svfl, first, i-1)
+        IF ( j+1 < last )  CALL quicksort_svf(svfl, j+1, last)
     END SUBROUTINE quicksort_svf
 
@@ -4469,11 +4193,11 @@
       TYPE (t_csf), INTENT(in) :: csf1,csf2
       LOGICAL                  :: res
-      IF ( csf1%ip < csf2%ip .OR.   &
-           (csf1%ip == csf2%ip .AND. csf1%itx < csf2%itx) .OR. &
-           (csf1%ip == csf2%ip .AND. csf1%itx == csf2%itx .AND. csf1%ity < csf2%ity) .OR. &
-           (csf1%ip == csf2%ip .AND. csf1%itx == csf2%itx .AND. csf1%ity == csf2%ity .AND.  &
-            csf1%itz < csf2%itz) .OR. &
-           (csf1%ip == csf2%ip .AND. csf1%itx == csf2%itx .AND. csf1%ity == csf2%ity .AND.  &
-            csf1%itz == csf2%itz .AND. csf1%isurfs < csf2%isurfs) ) THEN
+      IF ( csf1%ip < csf2%ip  .OR.    &
+           (csf1%ip == csf2%ip  .AND.  csf1%itx < csf2%itx)  .OR.  &
+           (csf1%ip == csf2%ip  .AND.  csf1%itx == csf2%itx  .AND.  csf1%ity < csf2%ity)  .OR.  &
+           (csf1%ip == csf2%ip  .AND.  csf1%itx == csf2%itx  .AND.  csf1%ity == csf2%ity  .AND.   &
+            csf1%itz < csf2%itz)  .OR.  &
+           (csf1%ip == csf2%ip  .AND.  csf1%itx == csf2%itx  .AND.  csf1%ity == csf2%ity  .AND.   &
+            csf1%itz == csf2%itz  .AND.  csf1%isurfs < csf2%isurfs) )  THEN
           res = .TRUE.
       ELSE
@@ -4483,8 +4207,8 @@
 
 
-    ! quicksort.f -*-f90-*-
-    ! Author: t-nissie, adaptation J.Resler
-    ! License: GPLv3
-    ! Gist: https://gist.github.com/t-nissie/479f0f16966925fa29ea
+!-- quicksort.f -*-f90-*-
+!-- Author: t-nissie, adaptation J.Resler
+!-- License: GPLv3
+!-- Gist: https://gist.github.com/t-nissie/479f0f16966925fa29ea
     RECURSIVE SUBROUTINE quicksort_csf(csfl, first, last)
         IMPLICIT NONE
@@ -4495,7 +4219,4 @@
 
         IF ( first>=last ) RETURN
-        IF ( (first+last)/2 <= 0 ) THEN
-            PRINT*, 'quicksort_csf', first, last, (first+last)/2
-        ENDIF
         x = csfl( (first+last)/2 )
         i = first
@@ -4508,15 +4229,15 @@
                 j=j-1
             ENDDO
-            IF (i >= j) EXIT
+            IF ( i >= j ) EXIT
             t = csfl(i);  csfl(i) = csfl(j);  csfl(j) = t
             i=i+1
             j=j-1
         ENDDO
-        IF (first < i-1) CALL quicksort_csf(csfl, first, i-1)
-        IF (j+1 < last)  CALL quicksort_csf(csfl, j+1, last)
+        IF ( first < i-1 ) CALL quicksort_csf(csfl, first, i-1)
+        IF ( j+1 < last )  CALL quicksort_csf(csfl, j+1, last)
     END SUBROUTINE quicksort_csf
 
     
-    SUBROUTINE merge_and_grow_csf(newsize)
+    SUBROUTINE usm_merge_and_grow_csf(newsize)
         INTEGER(iwp), INTENT(in)            :: newsize  !< new array size after grow, must be >= ncsfl
                                                         !< or -1 to shrink to minimum
@@ -4524,14 +4245,10 @@
         TYPE(t_csf), DIMENSION(:), POINTER  :: acsfnew
 
-        IF ( newsize == -1 ) THEN
-            !-- merge in-place
+        IF ( newsize == -1 )  THEN
+!--         merge in-place
             acsfnew => acsf
         ELSE
-            !-- allocate new array
-            IF ( debug_prints  .AND.  time_do3d < dt_3d )  THEN
-                WRITE(9,*) 'New dimmension of acsf array set to ', newsize
-                FLUSH(9)
-            ENDIF
-            IF ( mcsf == 0 ) THEN
+!--         allocate new array
+            IF ( mcsf == 0 )  THEN
                 ALLOCATE( acsf1(newsize) )
                 acsfnew => acsf1
@@ -4542,35 +4259,27 @@
         ENDIF
 
-        IF ( ncsfl >= 1 ) THEN
-            !-- sort csf in place (quicksort)
-            IF ( debug_prints  .AND.  time_do3d < dt_3d )  THEN            
-                WRITE(9,*) myid, 'start csf sort'
-                FLUSH(9)
-            ENDIF
+        IF ( ncsfl >= 1 )  THEN
+!--         sort csf in place (quicksort)
             CALL quicksort_csf(acsf,1,ncsfl)
 
-            !-- while moving to a new array, aggregate canopy sink factor records with identical box & source
-            IF ( debug_prints  .AND.  time_do3d < dt_3d )  THEN
-                WRITE(9,*) myid, 'csf merge and grow with', ncsfl, 'boxes'
-                FLUSH(9)
-            ENDIF
+!--         while moving to a new array, aggregate canopy sink factor records with identical box & source
             acsfnew(1) = acsf(1)
             iwrite = 1
             DO iread = 2, ncsfl
-                !-- here acsf(kcsf) already has values from acsf(icsf)
-                IF (acsfnew(iwrite)%itx == acsf(iread)%itx &
-                        .AND. acsfnew(iwrite)%ity == acsf(iread)%ity &
-                        .AND. acsfnew(iwrite)%itz == acsf(iread)%itz &
-                        .AND. acsfnew(iwrite)%isurfs == acsf(iread)%isurfs) THEN
-                    !-- We could simply take either first or second rtransp, both are valid. As a very simple heuristic about which ray
-                    !-- probably passes nearer the center of the target box, we choose DIF from the entry with greater CSF, since that
-                    !-- might mean that the traced beam passes longer through the canopy box.
-                    IF (acsfnew(iwrite)%rsvf < acsf(iread)%rsvf) THEN
+!--             here acsf(kcsf) already has values from acsf(icsf)
+                IF ( acsfnew(iwrite)%itx == acsf(iread)%itx &
+                         .AND.  acsfnew(iwrite)%ity == acsf(iread)%ity &
+                         .AND.  acsfnew(iwrite)%itz == acsf(iread)%itz &
+                         .AND.  acsfnew(iwrite)%isurfs == acsf(iread)%isurfs )  THEN
+!--                 We could simply take either first or second rtransp, both are valid. As a very simple heuristic about which ray
+!--                 probably passes nearer the center of the target box, we choose DIF from the entry with greater CSF, since that
+!--                 might mean that the traced beam passes longer through the canopy box.
+                    IF ( acsfnew(iwrite)%rsvf < acsf(iread)%rsvf )  THEN
                         acsfnew(iwrite)%rtransp = acsf(iread)%rtransp
                     ENDIF
                     acsfnew(iwrite)%rsvf = acsfnew(iwrite)%rsvf + acsf(iread)%rsvf
-                    !-- advance reading index, keep writing index
+!--                 advance reading index, keep writing index
                 ELSE
-                    !-- not identical, just advance and copy
+!--                 not identical, just advance and copy
                     iwrite = iwrite + 1
                     acsfnew(iwrite) = acsf(iread)
@@ -4578,17 +4287,9 @@
             ENDDO
             ncsfl = iwrite
-            IF ( debug_prints  .AND.  time_do3d < dt_3d )  THEN
-                WRITE(9,*) myid, 'csf merge and grow completed,', ncsfl, 'boxes remaining'
-                FLUSH(9)
-            ENDIF
         ENDIF
 
-        IF ( newsize == -1 ) THEN
-            !-- allocate new array and copy shrinked data
-            IF ( debug_prints  .AND.  time_do3d < dt_3d )  THEN
-                WRITE(9,*) 'Final dimmension of acsf array set to ', ncsfl
-                FLUSH(9)
-            ENDIF
-            IF ( mcsf == 0 ) THEN
+        IF ( newsize == -1 )  THEN
+!--         allocate new array and copy shrinked data
+            IF ( mcsf == 0 )  THEN
                 ALLOCATE( acsf1(ncsfl) )
                 acsf1(1:ncsfl) = acsf2(1:ncsfl)
@@ -4599,6 +4300,6 @@
         ENDIF
 
-        !-- deallocate old array
-        IF ( mcsf == 0 ) THEN
+!--     deallocate old array
+        IF ( mcsf == 0 )  THEN
             mcsf = 1
             acsf => acsf1
@@ -4610,11 +4311,11 @@
         ENDIF
         ncsfla = newsize
-    END SUBROUTINE merge_and_grow_csf
-
-    
-    ! quicksort.f -*-f90-*-
-    ! Author: t-nissie, adaptation J.Resler
-    ! License: GPLv3
-    ! Gist: https://gist.github.com/t-nissie/479f0f16966925fa29ea
+    END SUBROUTINE usm_merge_and_grow_csf
+
+    
+!-- quicksort.f -*-f90-*-
+!-- Author: t-nissie, adaptation J.Resler
+!-- License: GPLv3
+!-- Gist: https://gist.github.com/t-nissie/479f0f16966925fa29ea
     RECURSIVE SUBROUTINE quicksort_csf2(kpcsflt, pcsflt, first, last)
         IMPLICIT NONE
@@ -4627,7 +4328,4 @@
 
         IF ( first>=last ) RETURN
-        IF ( (first+last)/2 <= 0 ) THEN
-            PRINT*, 'quicksort_csf', first, last, (first+last)/2
-        ENDIF
         x = kpcsflt(:, (first+last)/2 )
         i = first
@@ -4640,5 +4338,5 @@
                 j=j-1
             ENDDO
-            IF (i >= j) EXIT
+            IF ( i >= j ) EXIT
             t1 = kpcsflt(:,i);  kpcsflt(:,i) = kpcsflt(:,j);  kpcsflt(:,j) = t1
             t2 = pcsflt(:,i);  pcsflt(:,i) = pcsflt(:,j);  pcsflt(:,j) = t2
@@ -4646,6 +4344,6 @@
             j=j-1
         ENDDO
-        IF (first < i-1) CALL quicksort_csf2(kpcsflt, pcsflt, first, i-1)
-        IF (j+1 < last)  CALL quicksort_csf2(kpcsflt, pcsflt, j+1, last)
+        IF ( first < i-1 ) CALL quicksort_csf2(kpcsflt, pcsflt, first, i-1)
+        IF ( j+1 < last )  CALL quicksort_csf2(kpcsflt, pcsflt, j+1, last)
     END SUBROUTINE quicksort_csf2
     
@@ -4655,39 +4353,10 @@
         LOGICAL                                     :: res
         res = ( (item1(3) < item2(3))                                                        &
-            .OR. (item1(3) == item2(3) .AND. item1(2) < item2(2))                            &
-            .OR. (item1(3) == item2(3) .AND. item1(2) == item2(2) .AND. item1(1) < item2(1)) &
-            .OR. (item1(3) == item2(3) .AND. item1(2) == item2(2) .AND. item1(1) == item2(1) &
-                .AND. item1(4) < item2(4)) )
+             .OR.  (item1(3) == item2(3)  .AND.  item1(2) < item2(2))                            &
+             .OR.  (item1(3) == item2(3)  .AND.  item1(2) == item2(2)  .AND.  item1(1) < item2(1)) &
+             .OR.  (item1(3) == item2(3)  .AND.  item1(2) == item2(2)  .AND.  item1(1) == item2(1) &
+                 .AND.  item1(4) < item2(4)) )
     END FUNCTION csf_lt2
 
     
  END MODULE urban_surface_mod
-
- 
-
-!------------------------------------------------------------------------------!
-!
-! Description:
-! ------------
-!> Temporary helper subroutine in order to provide the value of the LOGICAL
-!> expression urban_surface to the MODULE radiation_model_mod. It is
-!> required there for a parameter check, but due to circular dependencies 
-!> between modules radiation_model_mod and urban_surface_mod, the urban_surface
-!> flag cannot directly be included via "USE".
-!> At a future stage, this shall be handled by SUBMODULES (available in 
-!> FORTRAN 2008)
-!------------------------------------------------------------------------------!
- SUBROUTINE get_usm_info( urban_surface_export )
- 
-    USE urban_surface_mod,                                                     &
-        ONLY:  urban_surface
-    
-    IMPLICIT NONE
-    
-    LOGICAL ::  urban_surface_export  !< auxiliary flag
-    
-    
-    urban_surface_export = urban_surface
-    
-
- END SUBROUTINE get_usm_info
Index: palm/trunk/SOURCE/user_init_urban_surface.f90
===================================================================
--- palm/trunk/SOURCE/user_init_urban_surface.f90	(revision 2008)
+++ palm/trunk/SOURCE/user_init_urban_surface.f90	(revision 2011)
@@ -21,5 +21,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Flag urban_surface is now defined in module control_parameters.
 ! 
 ! Former revisions:
@@ -39,5 +39,6 @@
     USE arrays_3d
     
-    USE control_parameters
+    USE control_parameters,                                                    &
+        ONLY:  urban_surface
     
     USE indices
